@echo off

rem %1 == x86 or x64
if "%1" == "" goto usage

if /i %1 == x86 goto run
if /i %1 == x64 goto run
goto usage

:run
set MSVS_VC_DIR=%ProgramFiles(x86)%\Microsoft Visual Studio\2017\Enterprise\VC
set VMPROTECT_DIR=%ProgramFiles%\VMProtect Professional

set BUILD_DIR=build_%1
set INCLUDE_PATH=%VMPROTECT_DIR%\Include\C
set LIB_PATH=%VMPROTECT_DIR%\Lib\Windows

set EXE_INPUT_FILE=%BUILD_DIR%\test.exe
set VMP_OUTPUT_FILE=%BUILD_DIR%\test_VMProtect.exe

set VMPROTECT_PROJECT_FILENAME=config.vmp

if not exist %BUILD_DIR% ( mkdir %BUILD_DIR% )

rem build
call "%MSVS_VC_DIR%\Auxiliary\Build\vcvarsall.bat" %1
@echo on
cl /nologo /c /EHa /I"%INCLUDE_PATH%" test.cpp /O2 /Fo"%BUILD_DIR%\test.obj"
link /nologo /LIBPATH:"%LIB_PATH%" VMProtectSDK64.lib "%BUILD_DIR%\test.obj" /out:"%EXE_INPUT_FILE%"
@echo off

rem protect
@echo on
"%VMPROTECT_DIR%\VMProtect_Con.exe" "%EXE_INPUT_FILE%" "%VMP_OUTPUT_FILE%" -pf "%VMPROTECT_PROJECT_FILENAME%"
@echo off

goto :eof

:usage
echo Error in script usage. The correct usage is:
echo     %0 [option]
echo where [option] is: x86 ^| x64
goto :eof
